<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">

    <meta name="viewport" content="width=device-width, initial-scale=1">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css"
        integrity="sha384-MCw98/SFnGE8fJT3GXwEOngsV7Zt27NXFoaoApmYm81iuXoPkFOJwJ8ERdknLPMO" crossorigin="anonymous">
    <title>task29.70+task29.80</title>
</head>

<body">
    <div class="container jumbotron">
        <h1 class="text-center p-lg-1"> Thông tin người dùng</h1>
        <div class="form-group">
            <label for="">First Name</label>
            <input id="input-first-name" type="text" class="form-control">
        </div>
        <div class="form-group">
            <label for="">Last Name</label>
            <input id="input-last-name" type="text" class="form-control">
        </div>
        <div class="form-group">
            <label for="">Country</label>
            <input id="input-country" type="text" class="form-control">
        </div>
        <div class="form-group">
            <label for="">Subject</label>
            <textarea id="textarea-subject" name="" id="" class=" form-control"></textarea>
        </div>
        <div class="form-row">
            <div class="col">
                <button onclick="onBtnSuaClick()" id="button-edit" class="btn btn-success w-50">Sửa</button>
            </div>
            <div class="col">
                <a class="nav justify-content-end">Quay lại</a>
            </div>
        </div>
    </div>
    </body>

</html>
<script>
    // Khi tải trang
    window.onload = function () {
        // Lấy dữ liệu Id từ query string
        var queryString = window.location.search;
        var urlParams = new URLSearchParams(queryString);
        var userId = urlParams.get("id");

        // Kiểm tra xem Id có trên query string hay không
        if (!userId) {
            alert("Không có Id trên query string!");
            // Quay ngược lại trang danh sách (29.60)
            window.location.href = "task29.60.html";
        } else {
            // Gọi API để lấy thông tin người dùng theo Id
            getUserById(userId);
        }
    }

    // Hàm gọi API để lấy thông tin người dùng theo Id
    function getUserById(userId) {
        var apiUrl = "http://203.171.20.210:8080/devcamp-register-java-api/users/" + userId;
        var xhttp = new XMLHttpRequest();
        xhttp.onreadystatechange = function () {
            if (this.readyState == 4 && this.status == 200) {
                var user = JSON.parse(this.responseText);
                // Điền dữ liệu user vào các trường trên form
                populateUserData(user);
            }
        };
        xhttp.open("GET", apiUrl, true);
        xhttp.send();
    }

    // Hàm điền dữ liệu user vào các trường trên form
    function populateUserData(user) {
        document.getElementById("input-first-name").value = user.firstname;
        document.getElementById("input-last-name").value = user.lastname;
        document.getElementById("input-country").value = user.country;
        document.getElementById("textarea-subject").value = user.subject;
    }

    // Hàm gọi REST API để cập nhật thông tin người dùng
    function updateUser(userId, firstName, lastName, country, subject) {
        var apiUrl = "http://203.171.20.210:8080/devcamp-register-java-api/users/" + userId;
        var xhttp = new XMLHttpRequest();
        xhttp.onreadystatechange = function () {
            if (this.readyState == 4) {
                if (this.status == 200) {
                    // Cập nhật thành công
                    alert("Cập nhật thông tin người dùng thành công!");
                } else {
                    // Cập nhật thất bại
                    alert("Cập nhật thông tin người dùng thất bại!");
                }
                // Quay lại trang danh sách (29.60)
                window.location.href = "task29.60.html";
            }
        };
        xhttp.open("PUT", apiUrl, true);
        xhttp.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
        var data = JSON.stringify({
            firstname: firstName,
            lastname: lastName,
            country: country,
            subject: subject
        });
        xhttp.send(data);
    }

    //ham click button sua
    function onBtnSuaClick() {
        var userId = window.location.search.split("=")[1];
        var firstName = document.getElementById("input-first-name").value;
        var lastName = document.getElementById("input-last-name").value;
        var country = document.getElementById("input-country").value;
        var subject = document.getElementById("textarea-subject").value;

        // Validate dữ liệu (ví dụ: kiểm tra các trường không được để trống)
        if (firstName.trim() === "" || lastName.trim() === "" || country.trim() === "" || subject.trim() === "") {
            alert("Vui lòng điền đầy đủ thông tin!");
        } else {
            // Gọi REST API để cập nhật thông tin người dùng
            updateUser(userId, firstName, lastName, country, subject);
        }
    }
    // Ấn Quay lại
    document.getElementsByClassName("nav justify-content-end")[0].addEventListener("click", function () {
        // Quay lại trang danh sách (29.60)
        window.location.href = "task29.60.html";
    });
</script>